import usb.core
import sys

device = usb.core.find(idVendor=0x0C17, idProduct=0x0D12)

if device is None:
    print ('Device not found')
    exit(1)

print("Timestamp; UID; X Position [mm]; Y Position [mm]; Z Position [mm]; X Quaternion; Y Quaternion; Z Quaternion; W Quaternion")

endpoint = device[0][(0,0)][0]

data = None
while True:
    try:
        data = device.read(endpoint.bEndpointAddress, endpoint.wMaxPacketSize)

        if (data[9] == 0x14):
        	if ( (len(sys.argv) == 1) or ( len(sys.argv) == 2 and int(sys.argv[1]) == data[7]) ):
		        posX = float(int.from_bytes([data[10], data[11], data[12]], byteorder='little', signed=True))/100.0
		        posY = float(int.from_bytes([data[13], data[14], data[15]], byteorder='little', signed=True))/100.0
		        posZ = float(int.from_bytes([data[16], data[17], data[18]], byteorder='little', signed=True))/100.0

		        quatX = float(int.from_bytes([data[19], data[20], data[21]], byteorder='little', signed=True))/1000000.0
		        quatY = float(int.from_bytes([data[22], data[23], data[24]], byteorder='little', signed=True))/1000000.0
		        quatZ = float(int.from_bytes([data[25], data[26], data[27]], byteorder='little', signed=True))/1000000.0
		        quatW = float(int.from_bytes([data[28], data[29], data[30]], byteorder='little', signed=True))/1000000.0

		        print(data[4], ";", data[7], ";", posX, ";", posY, ";", posZ, ";", quatX, ";", quatY, ";", quatZ, ";", quatW)

    except usb.core.USBError as e:
        data = None
        if e.args == ('Operation timed out',):
            continue